﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace luento_wpf
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
      //  private int laskuri = 0;
        public MainWindow()
        {
            InitializeComponent();
        }

        private void buttonLaskuri_Click(object sender, RoutedEventArgs e)
        {
            Laskuri++;
//            laskuri++;
//            labelLaskuri.Content = laskuri.ToString();
        }

        public static readonly DependencyProperty LaskuriProperty = DependencyProperty.Register(
                           "Laskuri",
                           typeof(int), // propertyn tietotyyppi
                           typeof(MainWindow), // luokka jossa property sijaitsee
                           new FrameworkPropertyMetadata(0,  // propertyn oletusarvo
                                FrameworkPropertyMetadataOptions.AffectsRender, // vaikuttaa luokan ulkoasuun (textbox päivittyy)
                                new PropertyChangedCallback(OnValueChanged),  // kutsutaan propertyn arvon muuttumisen jälkeen
                                new CoerceValueCallback(MuutaLaskuria))); // kutsutaan ennen propertyn arvon muutosta

        // seuraavat tehtävä juuri näin. Ei mitään tarkistuksien lisäämistä
        public int Laskuri
        {
            get { return (int)GetValue(LaskuriProperty); }
            set { SetValue(LaskuriProperty, value); }
        }
        
        // tätä kutsutaan ennen laskurin muuttamista ja voidaan tässä vaiheessa
        // tehdä tarkistuksia ja muuttaa laskuriin asetettavaa arvoa
        private static object MuutaLaskuria(DependencyObject element, object value)
        {
            int luku = (int)value;
            if (luku < 0) value = 0;

            return luku;
        }

        // Laskuria on muutettu. Päivitetään tieto myös textboxiin
        // parempi olisi bindata textbox tähän propertyyn:
        // {Binding ElementName=IkkunanNimi, Path=Laskuri}
        private static void OnValueChanged(DependencyObject obj, DependencyPropertyChangedEventArgs args)
        {

//              MainWindow o = (MainWindow)obj;
//              o.labelLaskuri.Content = args.NewValue; 
        }


    }
}
